sub pig_latin {
    my @piggie = split /\b/, shift; 

    for (@piggie) {	# by word
	 
	  next unless /^[a-zA-Z]/;

      my ($allupper,$firstupper);

	  $allupper = "\U$_" eq $_
	  	or
  	  $firstupper = "\u\L$_" eq $_; # if it's allupper, then
	  								# it's not firstupper 

      $_ =lc;


      # append "way" if word starts with an un'y' vowel
      (s/^[aeiou]+// and $_.='way') or

      # copy leading consonants to the end of the word,
      # not counting "qu"
	  # if there is no vowels (!), just move the first
	  # consonant to the end of the word
	  s/^(.*?)([aeiouy].*)$/$2$1/ or s/(.)(.*)/$2$1/;

      $_ .= "ay" unless /ay$/; 
      
      # sickness.
	  $_ .= $1 if s/([,.!?\$])//;
     
	  # put it back in its original format
      if( $allupper )
	  { 
	    $_ = uc; 
	  }
	  elsif( $firstupper )
	  {
	  	$_ = ucfirst; 
	  }
    }

	return join '', @piggie;
}

sub psycho
{
	my $sentence = shift;

	$sentence =~ s/(\w)/ rand()<0.5?uc$1:lc$1 /eg;

	return $sentence;
}

sub drunk
{
	my $sentence = shift;
	my $level = 0.15;

	$sentence =~ s/([aeiou])/(rand()<$level)?'u':$1/eg;

	$sentence =~ s/(\w)/rand()<$level?"'":$1 /eg;

	$sentence =~ s/(\w)(\w)/rand()<$level?$2.$1:$1.$2 /eg;

	return $sentence;
}

sub wheeler
{
	my @number = qw/oh wun too tree fower fife six seven ait niner/;

	my @alphabet = qw/
Alpha Bravo Chariot Delta Echo Foxtrot Guild Hazat Imperial
Jumpgate Kraken Lord Muster Noble Oblate Pilgrim Quest Romeo
Sister Tango Uniform Void Whiskey Xeno Ypsilon Zombie/;

	my $sentence = shift;

 $sentence =~	s/([A-Z]{2,})/ join '-', map $alphabet[ ord($_)-ord('A') ], split '', $1/eg;

    $sentence =~ s/(\d+)/join'-',map $number[$_], split '', $1/eg;

	return $sentence;

}

sub rot13
{
	my $s = shift;
	$s =~ y/a-zA-Z/n-za-mN-ZA-M/;
	return $s;
}

sub vorox
{
	$_ = shift;
	
	s/\bI\b/Gaalgen/g;  # me barbarian :)
	s/\bam\b/is/g;
 
	s/\b(the|is) / 0.5 < rand() ? "$1 ": ''  /gei; # forget to say some words
 
	s/r/'r' x(1+rand(4)) /ieg;      # great => grreat
	s/s/z/g;        # sea => zea
	s/c/sk/g;   # nice => niske
	s/o?u/oo/g;   # you => yoo, tutorial => tootorrial
 
	s/ion/ioun/g; # institution => institootioun
	s/([^l])le\b/$1el/g;  # table => tabel
 
	# try to mimick a halted speech
	s/(\w\b)/ $1. ( rand() < 0.1 ? ' ..rr..':'' ) /ge;
 
	# e can becomes a ee...
	s/(e\B)/e x (1+rand(2))/gie;

	return $_;
}

sub Reverse
{
	my $line = shift;

	$line =~ s/"([^"]*)/'"'.reverse $1/eg;

	return $line;
}

%speech_filter_lib =
	( drunk     => \&drunk,
	  wheeler   => \&wheeler,
	  psycho    => \&psycho,
	  reverse   => \&Reverse,
	  'pig latin' => \&pig_latin,
	  rot13 => \&rot13,
	  vorox => \&vorox );


=pod

=head1 SPEECH FILTER

Ever wanted to have your character speak pig latin, but you 
don't want going insane ypetay tway ikelay histay? Rejoice,
for it is possible to set a speech filter that will convert
everything that your character says in whatever foul jargon
the filter is programmed to create. 

