use vars qw/ $ycq_mw %ycq /;

sub Ycq::start
{
		return if $ycq_mw;  # a window's already opened.
        $ycq_mw = $mw->Toplevel( -title => 'ycq', -width => 100,
                                                  -height => 300 );

        $ycq_mw->bind( '<Destroy>' => sub{ $ycq_mw = undef; %ycq = (); } );
}

sub Ycq::add_page 
{
    my ( $name, $text ) = @_;

	unless( $ycq{ $name } )
	{
		$ycq{ $name }[0] = 
			$ycq_mw->Button( -text => $name,
	  					     -command => sub { Ycq::show( $name ) }
					       )->pack( -expand => 0, anchor => 'c' );
	}

	$ycq{ $name }[1] .= "\n" . $text;

	# signal a new message is there
	$ycq{ $name }[0]->configure( -foreground => 'red' );
}

sub Ycq::show
{
	my $name = shift;
	$ycq{$name}[0]->configure( -foreground => 'black' );

	my $mw = $mw->Toplevel( -title => $name );

	my $t = $mw->Scrolled( 'ROText', -wrap => 'word', -class => 'UI',
							-height => 15,  -width => 50 , -scrollbars => 'e'
						)->pack( -expand => 1, -fill => 'both' );

	$t->insert( 'end', $ycq{$name}[1] );

	# reply button
	$mw->Button( -text => 'reply',
				-command => sub{ Forms::page( $name ); $mw->destroy; }
				)->pack( -side => 'right', -anchor => 'e' );

	# remove button
	$mw->Button( -text    => 'remove',
				 -command => sub{ $ycq{ $name }[0]->packForget; 
				                        undef $ycq{ $name };
				 					     $mw->destroy; }
			   )->pack( -side => 'right', -anchor => 'e' );
}


1;
